function resu = strncmp(A, B, n);

%# function resu = strncmp(A, B, n)
  %# Implements the strncmp func when at least one argument is a dataframe.

  %% Copyright (C) 2009-2015 Pascal Dupuis <cdemills@gmail.com>
  %%
  %% This file is part of Octave.
  %%
  %% Octave is free software; you can redistribute it and/or
  %% modify it under the terms of the GNU General Public
  %% License as published by the Free Software Foundation;
  %% either version 2, or (at your option) any later version.
  %%
  %% Octave is distributed in the hope that it will be useful,
  %% but WITHOUT ANY WARRANTY; without even the implied
  %% warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
  %% PURPOSE.  See the GNU General Public License for more
  %% details.
  %%
  %% You should have received a copy of the GNU General Public
  %% License along with Octave; see the file COPYING.  If not,
  %% write to the Free Software Foundation, 51 Franklin Street -
  %% Fifth Floor, Boston, MA 02110-1301, USA.
  
  %#
  %# $Id$
  %#

  if (isa (A, 'dataframe'))
    resu = logical (zeros (size (A)));
    for indc = (1:A._cnt(2))
      indr = feval (@strncmp, A._data{indc}(:, A._rep{indc}), B, n);
      resu(:, indc, A._rep{indc}) = indr;
    end
  else
    resu = logical (zeros (size (B)));
    for indc = (1:B._cnt(2))
      indr = feval (@strncmp, A, B._data{indc}(:, B._rep{indc}), n);
      resu(:, indc, B._rep{indc}) = indr;
    end
  end

endfunction
